<?php
add_filter( 'woocommerce_quantity_input_args', function ( $args, $product ) {
	$args['product'] = $product;

	$product_data = dwd_wc_get_product_data( $product );
	if ( ! $product_data ) {
		return $args;
	}

	try {
		$api              = DWD_WC_API_Helper::getInstance();
		$valid_quantities = $api->getQuantities( $product_data['uuid'], $product_data['attributes'] );
	} catch ( Exception $e ) {
		return $args;
	}

	$min  = min( $valid_quantities );
	$max  = max( $valid_quantities );
	$step = count( $valid_quantities ) >= 2 ? $valid_quantities[1] - $valid_quantities[0] : 1;

	$args['min_value'] = $min;
	$args['max_value'] = $max;
	$args['step']      = $step;

	// add valid quantities
	return $args;
}, 10, 2 );